import matlab.engine
import sys

sys.path.insert(0, '/Algorithm')

# IMPORTS ALGORITHM
from Algorithm import ADALINE

# IMPORTS PARAMETERS
import Parameters as Parameters


# INITIALIZE PARAMETERS TO ADALINE
def Initialize():
    # Initialize Algorithm Parameters inside ADALINE
    ADALINE.G.total_budget = Parameters.AlgorithmParameters[0]
    ADALINE.G.min_sample = Parameters.AlgorithmParameters[1]
    ADALINE.G.alpha = Parameters.AlgorithmParameters[2]
    ADALINE.G.iseed = Parameters.AlgorithmParameters[3]
    ADALINE.G.iseed_perturb = Parameters.AlgorithmParameters[4]
    ADALINE.G.iteration_max = Parameters.AlgorithmParameters[5]
    ADALINE.G.imax = Parameters.AlgorithmParameters[6]
    ADALINE.G.s = Parameters.AlgorithmParameters[7]
    ADALINE.G.c = Parameters.AlgorithmParameters[8]

    # Initialize dimensions and total neighbors for the problem
    ADALINE.G.dimension = len(Parameters.xStart)
    ADALINE.G.total_neighbors = 2 * len(Parameters.xStart)

    # Initialize seeds for Oracle Call
    ADALINE.Dynamic.output_seed = [ADALINE.G.iseed] * (ADALINE.G.total_budget+ 100)

    # Initialize Array of Decision Variables across Iterations
    ADALINE.DecisionVariable.x = [[0 for j in range(ADALINE.G.dimension)] for i in range(ADALINE.G.iteration_max)]

    # Initialize Oracle Parameters inside Oracle Class
    ADALINE.G.oracle_parameter[0] = len(Parameters.xStart)
    ADALINE.G.optType = Parameters.OracleParameters[1]
    # ADALINE.G.oracle_parameter[1] = Parameters.OracleParameters[3][0]
    # ADALINE.G.oracle_parameter[2] = Parameters.OracleParameters[3][1]



# EXECUTE ADALINE ON THE PROBLEM
Initialize()
matlabEng = matlab.engine.connect_matlab()
ADALINE.ADALINE(Parameters.xStart, Parameters.OracleParameters[0], matlabEng)
matlabEng.quit()
