from __future__ import division
# ---------------------------------------------------------------------------------------------------------------------
#                           PRASANNA RAGAVAN, RAGHU PASUPATHY                          DECEMBER 2016
# PARAMETERS FOR ADALINE ARE SET USING THIS SCRIPT. FOLLOW THE GUIDE FOR SETTING OPTIONAL, AND REQUIRED PARAMETERS
# ---------------------------------------------------------------------------------------------------------------------
#  (I) ALGORITHM PARAMETERS  -  1. budget               - Total Simulation Budget (required)
#                               2. minSampleSize        - Minimum Sample Size (optional, default 2)
#                               3. alpha                - Confidence Level for Adaptive Sampling (required)
#                               4. algorithmSeed        - starting seed for Simulation Calls (required)
#                               5. perturbationSeed     - starting seed for Random Perturbation (required)
#                               6. iterationMax         - maximum number of iterations (book-keeping, optional)
#                               7. lsMax                - maximum number of line search iterations (optional)
#                               8. s                    - initial step length (optional)
#                               9. c                    - multiplier for step length (optional)
#
# (II) ORACLE PARAMETERS    -   1. problem              - name of the problem to be tested (required)
#                               2. optType              - "minimize" or "maximize"
#
#
# (III) STARTING POINT      -   1. xStart               - Starting Point for ADALINE (required)
# ---------------------------------------------------------------------------------------------------------------------
############################################################################################
# ALGORITHM PARAMETERS
############################################################################################
# Total Simulation Budget
budget = 2500
# Minimum Sample Size for Adaptive Sampling
minSampleSize = 3
# Confidence Level
alpha = 0.90
# Starting Seeds for the Algorithm
algorithmSeed = 422512
perturbationSeed = 8987067
# Maximum Number of Iterations
iterationMax = 1000

# Default Parameters (No Change Required)
# Maximum Number of Line Search Iterations
lsMax = 15
# Initial Step Length in Line Search
s = 2
# Multiplier for Step Length in Line Search
c = 2

############################################################################################
# ORACLE PARAMETERS
############################################################################################
# Name of the Problem
problem = "ATO"
# Objective function maximization or minimization
optType = "maximize"


############################################################################################
# STARTING SOLUTION
############################################################################################
xStart = [16] * 8

############################################################################################
# DO NOT CHANGE ANY OF THE FOLLOWING
############################################################################################

AlgorithmParameters = [budget, minSampleSize,
                       alpha, algorithmSeed, perturbationSeed,
                       iterationMax, lsMax, s, c]

OracleParameters = [problem, optType]


